diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/character.cpp alien-rc4/src//game/server/entities/character.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/character.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/character.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -653,6 +1297,23 @@ void CCharacter::TickDefered()
 	}
 }
 
+void CCharacter::TickPaused()
+{
+	if(GameServer()->m_pController->MutGameRunning() == 0)
+		return;
+
+	++m_AttackTick;
+	++m_DamageTakenTick;
+	++m_Ninja.m_ActivationTick;
+	++m_ReckoningTick;
+	if(m_LastAction != -1)
+		++m_LastAction;
+	if(m_aWeapons[m_ActiveWeapon].m_AmmoRegenStart > -1)
+		++m_aWeapons[m_ActiveWeapon].m_AmmoRegenStart;
+	if(m_EmoteStop > -1)
+		++m_EmoteStop;
+}
+
 bool CCharacter::IncreaseHealth(int Amount)
 {
 	if(m_Health >= 10)
@@ -669,17 +1330,33 @@ bool CCharacter::IncreaseArmor(int Amoun
 	return true;
 }
 
+bool CCharacter::DecreaseArmor(int Amount)
+{
+        if(m_Armor <= 0)
+                return false;
+        m_Armor = clamp(m_Armor-Amount, 0, 10);
+        return true;
+}
+
 void CCharacter::Die(int Killer, int Weapon)
 {
+	int ModeSpecial = 0;
 	// we got to wait 0.5 secs before respawning
 	m_pPlayer->m_RespawnTick = Server()->Tick()+Server()->TickSpeed()/2;
-	int ModeSpecial = GameServer()->m_pController->OnCharacterDeath(this, GameServer()->m_apPlayers[Killer], Weapon);
+	if(Killer < 0 && Weapon > -1)
+	{
+		Killer = m_pPlayer->GetCID();
+		Weapon = -1;
+	}
 
-	char aBuf[256];
+	if(Killer >= 0)
+		ModeSpecial = GameServer()->m_pController->OnCharacterDeath(this, GameServer()->m_apPlayers[Killer], Weapon);
+		
+	/*char aBuf[256];
 	str_format(aBuf, sizeof(aBuf), "kill killer='%d:%s' victim='%d:%s' weapon=%d special=%d",
 		Killer, Server()->ClientName(Killer),
 		m_pPlayer->GetCID(), Server()->ClientName(m_pPlayer->GetCID()), Weapon, ModeSpecial);
-	GameServer()->Console()->Print(IConsole::OUTPUT_LEVEL_DEBUG, "game", aBuf);
+	GameServer()->Console()->Print(IConsole::OUTPUT_LEVEL_DEBUG, "game", aBuf);*/
 
 	// send the kill message
 	CNetMsg_Sv_KillMsg Msg;
@@ -688,10 +1365,128 @@ void CCharacter::Die(int Killer, int Wea
 	Msg.m_Weapon = Weapon;
 	Msg.m_ModeSpecial = ModeSpecial;
 	Server()->SendPackMsg(&Msg, MSGFLAG_VITAL, -1);
-
 	// a nice sound
 	GameServer()->CreateSound(m_Pos, SOUND_PLAYER_DIE);
 
+	// Victim is human
+	if(m_pPlayer->m_MutatorTeam >= TEAM_HUMAN)
+        {
+		if(GameServer()->m_pController->MutGameRunning())
+			GameServer()->SendBroadcast("You are now a Mutant!", m_pPlayer->GetCID());
+
+		if(Killer != m_pPlayer->GetCID() && Killer >= 0)	
+		{
+			if(GameServer()->m_apPlayers[Killer])
+			{
+				// Killer was human (teamkiller)
+				if(GameServer()->m_apPlayers[Killer]->m_MutatorTeam > TEAM_MUTANT)
+				{
+					GameServer()->m_apPlayers[Killer]->m_Score--;
+					GameServer()->m_apPlayers[Killer]->m_BonusScore--;
+					GameServer()->m_apPlayers[Killer]->m_BonusScore2--;
+					GameServer()->m_apPlayers[Killer]->m_MultiScore = 0;
+					GameServer()->m_apPlayers[Killer]->m_MultiScoreTick = Server()->Tick();
+					Mutate();
+					GameServer()->CreateSound(m_Pos, SOUND_PLAYER_PAIN_LONG);
+					if(GameServer()->m_pController->MutGameRunning())
+                				return;
+				}
+				// Killer was mutant
+				else 
+				{	
+					if(Server()->Tick() - GameServer()->m_apPlayers[Killer]->m_MultiScoreTick >= 0)
+						GameServer()->m_apPlayers[Killer]->m_MultiScore = 1; 
+					else
+						GameServer()->m_apPlayers[Killer]->m_MultiScore++;
+
+					GameServer()->m_apPlayers[Killer]->m_Score += (1 * GameServer()->m_apPlayers[Killer]->m_MultiScore);
+
+					// Extra bonus for hero
+					if(m_pPlayer->m_MutatorTeam == TEAM_HERO)
+					{
+						GameServer()->m_apPlayers[Killer]->m_Score++;
+						GameServer()->m_apPlayers[Killer]->m_BonusScore++;
+					}
+
+					GameServer()->m_apPlayers[Killer]->m_MultiScoreTick = Server()->Tick() + 2 * Server()->TickSpeed();
+					GameServer()->m_apPlayers[Killer]->m_BonusScore++;
+					if(GameServer()->m_apPlayers[Killer]->m_BonusScore >= g_Config.m_SvMetamorphoseCount)
+					{
+						GameServer()->m_apPlayers[Killer]->m_BonusScore = 0;
+						CCharacter * pMutChar = GameServer()->m_apPlayers[Killer]->GetCharacter();
+						if(pMutChar)
+							pMutChar->Metamorphose();	
+					}
+					if(Weapon != WEAPON_RIFLE) // if not black-hole weapon
+					{
+						Mutate();
+						GameServer()->CreateSound(m_Pos, SOUND_PLAYER_PAIN_LONG);
+                				return;
+					}
+				}
+			}
+		}
+		else
+		// Killer was "world"
+		{
+			Mutate();
+			m_pPlayer->m_Score--;	
+		}
+        }
+	else // Victim is mutant
+	{
+		if(Killer != m_pPlayer->GetCID() && Killer >= 0)
+		{
+			if(GameServer()->m_apPlayers[Killer])
+			{
+				// Killer is human 
+				if(GameServer()->m_apPlayers[Killer]->m_MutatorTeam >= TEAM_HUMAN)
+				{
+					if(Server()->Tick() - GameServer()->m_apPlayers[Killer]->m_MultiScoreTick >= 0)
+						GameServer()->m_apPlayers[Killer]->m_MultiScore = 1; 
+					else
+						GameServer()->m_apPlayers[Killer]->m_MultiScore++;
+
+					GameServer()->m_apPlayers[Killer]->m_Score += (1 * GameServer()->m_apPlayers[Killer]->m_MultiScore);
+					GameServer()->m_apPlayers[Killer]->m_MultiScoreTick = Server()->Tick() + 2 * Server()->TickSpeed();
+					
+					if(GameServer()->m_apPlayers[Killer]->m_MutatorTeam != TEAM_HERO)
+						GameServer()->m_apPlayers[Killer]->m_BonusScore++;
+
+					if(GameServer()->m_apPlayers[Killer]->m_BonusScore >= g_Config.m_SvHeroBecameScore && GameServer()->m_apPlayers[Killer]->m_MutatorTeam != TEAM_HERO)
+					{
+						CCharacter * pHeroChar;
+						pHeroChar = GameServer()->m_apPlayers[Killer]->GetCharacter();
+						if(pHeroChar)
+						{
+							GameServer()->SendBroadcast("You became a hero", GameServer()->m_apPlayers[Killer]->GetCID());
+							char bBuf[512];
+							str_format(bBuf,sizeof(bBuf),"%s becames a hero", 
+									Server()->ClientName(GameServer()->m_apPlayers[Killer]->GetCID()));
+        						GameServer()->SendChatTarget(-1, bBuf);
+							pHeroChar->BecameHero(1);
+						}
+					}
+					else if(g_Config.m_SvAutoResearchScore)
+					{
+						GameServer()->m_apPlayers[Killer]->m_BonusScore2++;
+						if(GameServer()->m_apPlayers[Killer]->m_BonusScore2 >= g_Config.m_SvAutoResearchScore)
+						{
+							GameServer()->m_apPlayers[Killer]->m_BonusScore2 = 0;
+							if(!g_Config.m_SvEmptyResearch || (g_Config.m_SvEmptyResearch && !GameServer()->m_pController->FoundHammerPickups()))
+							{
+								CCharacter * pHumChar = GameServer()->m_apPlayers[Killer]->GetCharacter();
+								if(pHumChar)
+									pHumChar->ScienceResearch(1);
+							}
+						}
+					}
+				}
+			}
+		}
+	}
+		
+
 	// this is for auto respawn after 3 secs
 	m_pPlayer->m_DieTick = Server()->Tick();
 
@@ -701,12 +1496,97 @@ void CCharacter::Die(int Killer, int Wea
 	GameServer()->CreateDeath(m_Pos, m_pPlayer->GetCID());
 }
 
+void CCharacter::TakeMinorDamage()
+{
+	m_DamageTaken++;
+	if(Server()->Tick() < m_DamageTakenTick+25)
+		GameServer()->CreateDamageInd(m_Pos, m_DamageTaken*0.25f, 1);
+	else
+	{
+		m_DamageTaken = 0;
+		GameServer()->CreateDamageInd(m_Pos, 0, 1);
+	}
+	m_DamageTakenTick = Server()->Tick();
+
+        m_Health--;
+	if(m_Health < 1)
+		Die(m_pPlayer->GetCID(), WEAPON_WORLD);
+}
+
 bool CCharacter::TakeDamage(vec2 Force, int Dmg, int From, int Weapon)
 {
 	m_Core.m_Vel += Force;
 
-	if(GameServer()->m_pController->IsFriendlyFire(m_pPlayer->GetCID(), From) && !g_Config.m_SvTeamdamage)
-		return false;
+	// Friendly fire is checked somewhat different below 
+	/*if(GameServer()->m_pController->IsFriendlyFire(m_pPlayer->GetCID(), From) && !g_Config.m_SvTeamdamage)
+		return false;*/
+
+	// Mutator 
+	if(From >= 0)
+	{
+		if(!g_Config.m_SvTeamdamage && From != m_pPlayer->GetCID() && GameServer()->m_apPlayers[From] 
+				&& (GameServer()->m_apPlayers[From]->m_MutatorTeam >= TEAM_HUMAN && m_pPlayer->m_MutatorTeam >= TEAM_HUMAN && !(m_Pos.y < 0 && Weapon == WEAPON_HAMMER)))
+			return false;	
+		if(GameServer()->m_apPlayers[From] && GameServer()->m_apPlayers[From]->m_MutatorTeam <= TEAM_MUTANT) 
+		{
+			if(Weapon != WEAPON_HAMMER)
+				return false;
+
+			if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+			{
+				if((IncreaseHealth(3) + IncreaseArmor(3)) > 0)
+				{
+					m_DamageTaken++;
+					if(Server()->Tick() < m_DamageTakenTick+25)
+        				{
+						// make sure that the damage indicators doesn't group together
+						GameServer()->CreateDamageInd(m_Pos, m_DamageTaken*0.25f, 3);
+					}
+					else
+					{
+ 						m_DamageTaken = 0;
+						GameServer()->CreateDamageInd(m_Pos, 0, 3);
+					}
+					m_DamageTakenTick = Server()->Tick();
+				}
+				return false;
+			}
+			else if(m_pPlayer->m_MutatorTeam == TEAM_HERO)
+			{
+				Dmg = 8;
+			}
+			else
+			{
+				Die(From, Weapon);
+				return true;
+			}
+		}
+	}
+
+	if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+	{
+		// Spawn Protection 
+		if(Server()->Tick() - m_MutanticSpawnProtection < 0)
+			return false;
+		
+		// Mutatic special protection (flashing eyes)
+		if(m_MutanticEyeOn == 1)
+		{
+			if(m_pPlayer->m_MutatorTeam == TEAM_MUTANT)
+				Dmg = 1;
+			else // Reaper that got flashing eyes increase health when hit...
+			{
+				IncreaseArmor(Dmg);
+				IncreaseHealth(Dmg);
+				int Mask = CmaskOne(m_pPlayer->GetCID());
+				GameServer()->CreateSound(m_Pos, SOUND_HIT, Mask);
+				return false;
+			}
+		}
+		else if(m_pPlayer->m_MutatorTeam == TEAM_REAPER && Weapon != WEAPON_RIFLE)
+			Dmg = max(1, Dmg/3);
+			
+	}
 
 	// m_pPlayer only inflicts half damage on self
 	if(From == m_pPlayer->GetCID())
@@ -777,7 +1657,7 @@ bool CCharacter::TakeDamage(vec2 Force,
 			if (pChr)
 			{
 				pChr->m_EmoteType = EMOTE_HAPPY;
-				pChr->m_EmoteStop = Server()->Tick() + Server()->TickSpeed();
+				pChr->m_EmoteStop = Server()->Tick() + 2 * Server()->TickSpeed();
 			}
 		}
 
@@ -799,6 +1679,19 @@ void CCharacter::Snap(int SnappingClient
 {
 	if(NetworkClipped(SnappingClient))
 		return;
+	
+
+	// Mutator - handle invisible 
+	if(m_Invisible)
+	{
+		if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+		{
+			if(GameServer()->m_apPlayers[SnappingClient]->m_MutatorTeam >= TEAM_HUMAN)  
+				return;
+		}
+		else if(GameServer()->m_apPlayers[SnappingClient]->m_MutatorTeam <= TEAM_MUTANT)
+			return;
+	}
 
 	CNetObj_Character *pCharacter = static_cast<CNetObj_Character *>(Server()->SnapNewItem(NETOBJTYPE_CHARACTER, m_pPlayer->GetCID(), sizeof(CNetObj_Character)));
 	if(!pCharacter)
@@ -819,10 +1712,29 @@ void CCharacter::Snap(int SnappingClient
 	}
 
 	// set emote
-	if (m_EmoteStop < Server()->Tick())
+	if(m_EmoteStop < Server()->Tick())
 	{
-		m_EmoteType = EMOTE_NORMAL;
+		if(m_pPlayer->m_MutatorTeam > TEAM_REAPER)
+			m_EmoteType = EMOTE_NORMAL;
+		else
+			m_EmoteType = EMOTE_ANGRY;
+
 		m_EmoteStop = -1;
+		m_MutanticEyeOn = 0;
+	} 
+	else if(m_MutanticEyeOn == 1)
+	{
+		if(Server()->Tick() - m_MutanticEyeFlipTick > 0)
+		{
+			m_MutanticEyeFlip = 1 - m_MutanticEyeFlip;
+		
+			m_MutanticEyeFlipTick = Server()->Tick() + 200 * Server()->TickSpeed() / 1000;
+			switch(m_MutanticEyeFlip)
+			{
+				case 0: m_EmoteType = EMOTE_NORMAL; break;
+				case 1: m_EmoteType = EMOTE_SURPRISE; break;
+			}
+		}
 	}
 
 	pCharacter->m_Emote = m_EmoteType;
@@ -853,3 +1765,464 @@ void CCharacter::Snap(int SnappingClient
 
 	pCharacter->m_PlayerFlags = GetPlayer()->m_PlayerFlags;
 }
+
+void CCharacter::Mutate()
+{
+	m_pPlayer->m_MutatorTeam = TEAM_MUTANT;
+	GiveWeapon(WEAPON_HAMMER, -1);
+	m_TurretActive = 0;
+	m_OnTurret = 0;
+	m_PrevOnTurret = 0;
+	m_pPlayer->m_ScienceCount = 0;
+	SetWeapon(WEAPON_HAMMER);
+	SetEmote(EMOTE_FLASHING,Server()->Tick() + 2500 * Server()->TickSpeed() / 1000);
+	m_AlienMetaTick = Server()->Tick() + 30 * Server()->TickSpeed();
+	IncreaseHealth(10);
+	m_Armor = 0;
+	m_pPlayer->m_MyHumanScore = m_pPlayer->m_Score;
+	m_pPlayer->m_Score = 0;
+	m_pPlayer->m_BonusScore = 0;
+	m_pPlayer->m_MultiScore = 0;
+	m_pPlayer->m_MultiScoreTick = Server()->Tick();
+	m_OnReapinator = 0;
+	m_PrevOnReapinator = 0;
+}
+
+void CCharacter::ReMutate()
+{
+	m_pPlayer->m_MutatorTeam = TEAM_HUMAN;
+	GiveWeapon(WEAPON_GUN,10);
+	GiveWeapon(WEAPON_HAMMER,-1);
+	m_OnTurret = 0;
+	m_PrevOnTurret = 0;
+	m_pPlayer->m_ScienceCount = 0;
+	SetWeapon(WEAPON_GUN);
+	SetEmote(EMOTE_FLASHING,Server()->Tick() + 2500 * Server()->TickSpeed() / 1000);
+	IncreaseHealth(10);
+	m_aWeapons[WEAPON_GUN].m_Got = 1;
+	m_pPlayer->m_MyMutantScore = m_pPlayer->m_Score;
+	m_pPlayer->m_Score = m_pPlayer->m_MyHumanScore;
+	m_pPlayer->m_BonusScore = 0;
+	m_pPlayer->m_MultiScore = 0;
+	m_pPlayer->m_MultiScoreTick = Server()->Tick();
+}
+
+void CCharacter::BecameHero(bool AirStrike)
+{
+	m_pPlayer->m_Score += 3;
+	m_pPlayer->m_MutatorTeam = TEAM_HERO;
+	GiveWeapon(WEAPON_SHOTGUN, 10);
+	SetWeapon(WEAPON_SHOTGUN);
+	IncreaseHealth(10);
+	m_pPlayer->m_BonusScore = 0;
+	m_pPlayer->m_MultiScore = 0;
+	m_pPlayer->m_MultiScoreTick = Server()->Tick();
+	if(AirStrike && g_Config.m_SvHeroAirstrike)
+	{
+		char bBuf[512];
+		str_format(bBuf,sizeof(bBuf),"%s %s", Server()->ClientName(m_pPlayer->GetCID()),g_Config.m_SvInfoGotAirstrike);
+		GameServer()->SendChatTarget(-1, bBuf);
+		m_OwnAirstrike++;
+	}
+	m_pPlayer->m_ScienceExplored |= SCIENCE_SHOTGUN_FORCEX2;
+}		
+
+void CCharacter::BecameReaper()
+{
+	m_pPlayer->m_Score += 3;
+	m_pPlayer->m_MutatorTeam = TEAM_REAPER;
+	IncreaseHealth(10);
+	IncreaseArmor(10);
+	m_pPlayer->m_BonusScore = 0;
+	
+	GiveWeapon(WEAPON_RIFLE,1);
+	m_aWeapons[WEAPON_RIFLE].m_Ammo = g_Config.m_SvReaperAmmo;
+	m_aWeapons[WEAPON_GUN].m_Got = 0;
+	m_aWeapons[WEAPON_GUN].m_Ammo = 0;
+	m_aWeapons[WEAPON_SHOTGUN].m_Got = 0;
+	m_aWeapons[WEAPON_SHOTGUN].m_Ammo = 0;
+	m_aWeapons[WEAPON_GRENADE].m_Got = 0;
+	m_aWeapons[WEAPON_GRENADE].m_Ammo = 0;
+	SetWeapon(WEAPON_HAMMER);
+	m_pPlayer->m_MultiScore = 0;
+	m_pPlayer->m_MultiScoreTick = Server()->Tick();
+}
+
+void CCharacter::Metamorphose()
+{
+	int Lottery = rand()%8;
+	IncreaseHealth(5);
+	IncreaseArmor(5);
+
+	if(!(m_pPlayer->m_Score >= g_Config.m_SvReaperMinScore && Lottery == 5))
+	{
+		Lottery = m_pPlayer->m_ScienceCount;
+		m_pPlayer->m_ScienceCount++;
+		if(Lottery > 4)
+			return;
+	}
+	
+	char aBuf[512];
+	char bBuf[512];
+
+	m_pPlayer->m_MutaticLevels |= 1 << Lottery; 
+
+	switch(Lottery)
+	{
+		case 0:
+			{
+				str_format(bBuf,sizeof(bBuf),"%s metamorphosed and gained starting-shields", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You gained starting-shields");
+			}
+			break;
+		case 1:
+			{
+				str_format(bBuf,sizeof(bBuf),"%s metamorphosed and gained biohazard-resistance", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You gained biohazard-resistance");
+			}
+			break;
+		case 2:
+			{
+				str_format(bBuf,sizeof(bBuf),"%s metamorphosed and gained alien-multijump", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You gained alien-multijump");
+			}
+			break;
+		case 3:
+			{
+				str_format(bBuf,sizeof(bBuf),"%s metamorphosed and gained alien-superhook", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You gained alien-superhook");
+			}
+			break;
+		case 4:
+			{
+				str_format(bBuf,sizeof(bBuf),"%s metamorphosed and gained alien-selfheal", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You gained alien-selfheal");
+			}
+			break;
+		case 5:
+			{
+				str_format(bBuf,sizeof(bBuf),"Alica-KI: WARNING: %s metamorphosed and became an alien-reaper!", Server()->ClientName(m_pPlayer->GetCID()));
+				str_format(aBuf,sizeof(aBuf),"You are now a Reaper!");
+				BecameReaper();
+			}
+			break;
+	}	
+
+	GameServer()->SendBroadcast(aBuf, m_pPlayer->GetCID());
+	if(Lottery == 5 || g_Config.m_SvBonusMsgOn)
+		GameServer()->SendChatTarget(-1, bBuf);
+}
+
+void CCharacter::ScienceResearch(bool AutoResearch)
+{
+	int Lottery = rand()%16;
+	int remember_me = 0;
+	char aBuf[512];
+	char bBuf[512];
+
+	m_pPlayer->m_ScienceCount = 0;
+
+
+	if(Lottery < 13)
+	{
+		if(m_pPlayer->m_ScienceExplored&(1 << Lottery) && Lottery < 9)
+		{
+			if(g_Config.m_SvSaveScienceScore && m_pPlayer->m_Score > g_Config.m_SvSaveScienceScore)
+			{
+				remember_me = 1; 
+				m_pPlayer->m_ScienceRemembered |= 1 << Lottery;
+				m_pPlayer->m_ScienceExplored |= 1 << Lottery;
+			}
+			else
+				Lottery = -1;
+		}
+		else
+			m_pPlayer->m_ScienceExplored |= 1 << Lottery;
+	}
+
+	if(Lottery > 12 || Lottery == -1 || (Lottery == 9 && m_pPlayer->m_MutatorTeam == TEAM_HERO))
+	{
+		if(!AutoResearch)
+		{
+			str_format(aBuf,sizeof(aBuf),"Scientific research: Failed!");
+			GameServer()->SendBroadcast(aBuf, m_pPlayer->GetCID());
+		}
+		return;
+	}
+
+	switch(Lottery)
+	{
+		case 0:
+			{
+				m_OwnLaserSubType[LASER_SUBTYPE_TELE] = true;
+				m_QueuedLaser = LASER_SUBTYPE_TELE;
+				m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_TELE;
+				GiveWeapon(WEAPON_RIFLE,10);
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Tele-Laserinator");
+					str_format(bBuf,sizeof(bBuf),"%s %s Tele-Laserinator", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Tele-Laserinator: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Tele-Laserinator", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 1:
+			{
+				m_OwnLaserSubType[LASER_SUBTYPE_HEALING] = true;
+				m_QueuedLaser = LASER_SUBTYPE_HEALING;
+				if(m_ActiveWeapon != WEAPON_RIFLE)
+					m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_HEALING;
+
+				GiveWeapon(WEAPON_RIFLE,g_Config.m_SvHealingAmmo,1);
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Healing-Laser");
+					str_format(bBuf,sizeof(bBuf),"%s %s Healing-Laser", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Healing-Laser: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Healing-Laser", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 2:
+			{
+				m_OwnLaserSubType[LASER_SUBTYPE_RIDDLE] = true;
+				m_QueuedLaser = LASER_SUBTYPE_RIDDLE;
+				m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_RIDDLE;
+				GiveWeapon(WEAPON_RIFLE,10);
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Riddle-Laser");
+					str_format(bBuf,sizeof(bBuf),"%s %s Riddle-Laser", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Riddle-Laser: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Riddle-Laser", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 3:
+			{
+				GiveWeapon(WEAPON_SHOTGUN,10);
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Shootgun MKII");
+					str_format(bBuf,sizeof(bBuf),"%s %s SG-MKII", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Shootgun MKII: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: SG-MKII", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 4:
+			{ 
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained SG-Ammo MKII");
+					str_format(bBuf,sizeof(bBuf),"%s %s SG-Ammo MKII", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"SG-Ammo MKII: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: SG-Ammo MKII", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 5:
+			{
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Cluster-Grenades");
+					str_format(bBuf,sizeof(bBuf),"%s %s Cluster-Grenades", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Cluster-Grenades: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Cluster-Grenades", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 6:
+			{
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Gun-Ammo MKII");
+					str_format(bBuf,sizeof(bBuf),"%s %s Gun-Ammo MKII", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Gun-Ammo MKII: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Gun-Ammo MKII", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 7:
+			{
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained SG-Speed-kit");
+					str_format(bBuf,sizeof(bBuf),"%s %s SG-Speed-kit", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"SG-Speed-kit: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: SG-Speed-kit", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 8:
+			{
+				if(!remember_me)
+				{
+					str_format(aBuf,sizeof(aBuf),"You gained Super-Battery");
+					str_format(bBuf,sizeof(bBuf),"%s %s Super-Battery", Server()->ClientName(m_pPlayer->GetCID()), AutoResearch == 1 ? g_Config.m_SvInfoGot : g_Config.m_SvInfoResearched);
+				}
+				else
+				{
+					str_format(aBuf,sizeof(aBuf),"Super-Battery: Saved!");
+					str_format(bBuf,sizeof(bBuf),"%s saved: Super-Battery", Server()->ClientName(m_pPlayer->GetCID()));
+				}
+			}
+			break;
+		case 9:
+			{
+				str_format(aBuf,sizeof(aBuf),"You became a hero");
+				str_format(bBuf,sizeof(bBuf),"%s gained: Hero-genetics", Server()->ClientName(m_pPlayer->GetCID()));
+				BecameHero(0);
+			}
+			break;
+		case 10:
+			{
+				str_format(aBuf,sizeof(aBuf),"You gained weapons refill.");
+				str_format(bBuf,sizeof(bBuf),"%s gained: Weapons refill", Server()->ClientName(m_pPlayer->GetCID()));
+				GiveWeapon(WEAPON_GUN,10);
+				GiveWeapon(WEAPON_SHOTGUN,10);
+				GiveWeapon(WEAPON_GRENADE,10);
+				GiveWeapon(WEAPON_RIFLE,10);
+				if(m_pPlayer->m_ScienceExplored&SCIENCE_LASER_HEALING)
+				{
+					if(m_ActiveWeapon != WEAPON_RIFLE)
+						m_aWeapons[WEAPON_RIFLE].m_SubType = LASER_SUBTYPE_HEALING;
+
+					GiveWeapon(WEAPON_RIFLE,g_Config.m_SvHealingAmmo,1);
+				}
+			}
+			break;
+		case 11:
+			{
+				str_format(aBuf,sizeof(aBuf),"You gained shields fillup");
+				str_format(bBuf,sizeof(bBuf),"%s gained: Shield fillup", Server()->ClientName(m_pPlayer->GetCID()));
+				IncreaseHealth(10);
+				IncreaseArmor(10);
+			}
+			break;
+		case 12:
+			{
+				if(!AutoResearch)
+					str_format(bBuf,sizeof(bBuf),"%s %s", Server()->ClientName(m_pPlayer->GetCID()), g_Config.m_SvInfoHackedAirstrike);
+				else
+					str_format(bBuf,sizeof(bBuf),"%s %s", Server()->ClientName(m_pPlayer->GetCID()), g_Config.m_SvInfoGotAirstrike);
+
+				str_format(aBuf,sizeof(aBuf),"You got an airstrike. (use /airstrike)");
+				m_OwnAirstrike++;
+			}
+			break;
+	}	
+	GameServer()->SendBroadcast(aBuf, m_pPlayer->GetCID());
+	if(g_Config.m_SvBonusMsgOn)
+		GameServer()->SendChatTarget(-1, bBuf);
+}
+
+vec2 CCharacter::GetVel()
+{
+	return m_Core.m_Vel;
+}
+                     
+void CCharacter::SetVel(vec2 Vel)
+{
+	m_Core.m_Vel = Vel;
+}
+
+void CCharacter::SetPos(vec2 Pos)
+{
+	m_Core.m_Pos = Pos;
+}
+
+void CCharacter::DestroyLaserWall()
+{
+	if(m_LaserWall)
+	{
+		GameServer()->m_World.DestroyEntity(m_LaserWall);
+		m_LaserWall = 0;
+	}
+}
+
+int CCharacter::GetActiveWeapon()
+{
+	return m_ActiveWeapon;
+}
+
+bool CCharacter::IsFiring()
+{
+	if((m_Input.m_Fire&1) != 0)
+		return 1;
+	else
+		return 0;
+}
+
+void CCharacter::SetOnScience(bool val)
+{
+	m_OnScience = val;
+	m_OnScienceOffTick = Server()->Tick() + 500 * Server()->TickSpeed() / 1000;
+}
+
+bool CCharacter::IsOnScience()
+{
+	return m_OnScience;
+}
+
+bool CCharacter::PrevOnScience()
+{
+	return m_PrevOnScience;
+}
+
+bool CCharacter::BreakCircuit()
+{
+	if(m_pPlayer->m_MutatorTeam <= TEAM_MUTANT)
+	{
+		GameServer()->m_pController->MutSetPowerSupply(0);
+		char aBuf[512];
+		str_format(aBuf,sizeof(aBuf),"\nAlica-AI: WARNING! Generator destroyed by %s!\n",Server()->ClientName(m_pPlayer->GetCID()));
+		GameServer()->SendChatTarget(-1, aBuf);
+		m_pPlayer->m_Score += 3;
+		SetEmote(EMOTE_FLASHING, Server()->Tick() + 2000 * Server()->TickSpeed() / 1000);
+		Metamorphose();
+		return true;
+	}
+	else
+		return false;
+}
+
+void CCharacter::SetShowInfoTick(int Tick)
+{
+	m_ShowInfoTick = Tick;
+}
+
+int CCharacter::GetShowInfoTick()
+{
+	return m_ShowInfoTick;
+}
+
+bool CCharacter::MutanticEyes()
+{
+	return m_MutanticEyeOn;
+}
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/character.h alien-rc4/src//game/server/entities/character.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/character.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/character.h	2012-06-14 23:57:39.000000000 +0200
@@ -8,6 +8,7 @@
 #include <game/generated/protocol.h>
 
 #include <game/gamecore.h>
+#include <game/server/entities/laser.h>
 
 enum
 {
@@ -30,6 +31,7 @@ public:
 	virtual void Destroy();
 	virtual void Tick();
 	virtual void TickDefered();
+	virtual void TickPaused();
 	virtual void Snap(int SnappingClient);
 
 	bool IsGrounded();
@@ -48,6 +50,7 @@ public:
 
 	void Die(int Killer, int Weapon);
 	bool TakeDamage(vec2 Force, int Dmg, int From, int Weapon);
+	void TakeMinorDamage();
 
 	bool Spawn(class CPlayer *pPlayer, vec2 Pos);
 	bool Remove();
@@ -55,7 +58,7 @@ public:
 	bool IncreaseHealth(int Amount);
 	bool IncreaseArmor(int Amount);
 
-	bool GiveWeapon(int Weapon, int Ammo);
+	bool GiveWeapon(int Weapon, int Ammo, int Special=0);
 	void GiveNinja();
 
 	void SetEmote(int Emote, int Tick);
@@ -63,10 +66,71 @@ public:
 	bool IsAlive() const { return m_Alive; }
 	class CPlayer *GetPlayer() { return m_pPlayer; }
 
+	// Mutator
+	void SetPreStartGame();
+	void Mutate();
+	void ReMutate();
+	void Metamorphose();
+	void ScienceResearch(bool AutoResearch);
+	void BecameHero(bool AirStrike);
+	void BecameReaper();
+	void AirStrike();
+
+	vec2 GetVel();
+	void SetVel(vec2 Vel);
+	void SetPos(vec2 Pos);
+	bool DecreaseArmor(int Amount);
+	int GetActiveWeapon();
+	bool IsFiring();
+	void CycleLaserSubTypes();
+	void DestroyLaserWall();
+	void SetOnScience(bool val);
+	bool IsOnScience();
+	bool PrevOnScience();
+	bool BreakCircuit();
+	void ShowScanResults();
+	void SetShowInfoTick(int Tick);
+	int GetShowInfoTick();
+	bool MutanticEyes();
+
 private:
+	
 	// player controlling this character
 	class CPlayer *m_pPlayer;
 
+	// Mutator
+	class CLaserWall *m_LaserWall;
+	int m_MutanticEmoteTick;
+	int m_BioHazardDamageTick;
+	int m_AlienMetaTick;
+	int m_MutanticSpawnProtection;
+	int m_MutanticArmorDJCount;
+	bool m_OnScience;
+	int m_OnScienceOffTick;
+	bool m_PrevOnScience;
+	bool m_Invisible;
+	bool m_PrevOnReapinator;
+	bool m_OnReapinator;
+
+	bool m_OnTurret;
+	bool m_TurretActive;
+	int m_TurretAmmo;
+	int m_PrevTurretSwitchAmmo;
+	bool m_PrevTurretSwitchGot;
+	bool m_PrevOnTurret;
+	int m_OwnAirstrike;
+	
+	int m_EnergyUpTick;
+	int m_OnEnergyUp;
+	int m_PrevOnEnergyUp;
+
+	int m_ShowInfoTick;
+
+        int m_Col1;
+        int m_Col2;
+        int m_Col3;
+        int m_Col4;
+	
 	bool m_Alive;
 
 	// weapon info
@@ -79,12 +143,21 @@ private:
 		int m_Ammo;
 		int m_Ammocost;
 		bool m_Got;
+		int m_SubType;
+		int m_SpecialAmmo;
+		int m_NormalAmmo;
 
 	} m_aWeapons[NUM_WEAPONS];
 
 	int m_ActiveWeapon;
 	int m_LastWeapon;
+
+	// Mutator 
 	int m_QueuedWeapon;
+	int m_QueuedLaser;
+	int m_LaserCycleTick;
+	bool m_LaserCycleInfoSwitch;
+	bool m_OwnLaserSubType[LASER_MAX_SUBTYPE];
 
 	int m_ReloadTimer;
 	int m_AttackTick;
@@ -94,6 +167,11 @@ private:
 	int m_EmoteType;
 	int m_EmoteStop;
 
+	// Mutator
+	bool m_MutanticEyeOn;
+	bool m_MutanticEyeFlip;
+	int m_MutanticEyeFlipTick;
+
 	// last tick that the player took any action ie some input
 	int m_LastAction;
 
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/flag.cpp alien-rc4/src//game/server/entities/flag.cpp
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/flag.cpp	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/flag.cpp	2012-06-14 23:57:39.000000000 +0200
@@ -23,6 +23,13 @@ void CFlag::Reset()
 	m_GrabTick = 0;
 }
 
+void CFlag::TickPaused()
+{
+	++m_DropTick;
+	if(m_GrabTick)
+		++m_GrabTick;
+}
+
 void CFlag::Snap(int SnappingClient)
 {
 	if(NetworkClipped(SnappingClient))
diff -rupN teeworlds-b177-r50edfd37-source/src//game/server/entities/flag.h alien-rc4/src//game/server/entities/flag.h
--- teeworlds-b177-r50edfd37-source/src//game/server/entities/flag.h	2011-07-31 23:17:00.000000000 +0200
+++ alien-rc4/src//game/server/entities/flag.h	2012-06-14 23:57:39.000000000 +0200
@@ -21,6 +21,7 @@ public:
 	CFlag(CGameWorld *pGameWorld, int Team);
 
 	virtual void Reset();
+	virtual void TickPaused();
 	virtual void Snap(int SnappingClient);
 };
 
